@ECHO OFF 


	echo ********************          Magewell ProCapture patch for skype        ******************** 
	echo ********************  !!! Please run with administrator permissions !!!  ******************** 
	echo Help : Y -- Set for skype    N -- Reset
	
	set /p ctrl=Input: 


	set regpth=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\ProCapture
	set num=0
	set dimension_list_value=0
	set max_out_width=0
	set max_out_height=0
	set processor_arch=x64
	set ven_id=PCI\VEN_1CD7

	if "%PROCESSOR_ARCHITECTURE%"=="x86" (
		set processor_arch=x86
	)
	
	if /i "%ctrl%"=="Y" (
		set dimension_list_value=0
		set max_out_width=1920
		set max_out_height=1080 
	) else (
		if /i "%ctrl%"=="N" (
			set dimension_list_value=1
			set max_out_width=0x7fffffff
			set max_out_height=0x7fffffff
		) else (
			echo Invalid input parameter
			pause
			exit
		)
	)
	
	echo.
	echo.
	echo =====================================================================
	echo ********************      Disable ProCapture     ********************

	cd /d %~dp0

	devcon_%processor_arch%\devcon.exe disable %ven_id%

	set /a num = 0

	echo.
	echo.
	echo =====================================================================
	echo ********************    Current DimensionList    ********************
	echo.
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /v DimensionList /s') do (
		echo Path : %%a|find /i "%regpth%"
		echo Key  : %%a|find /i "DimensionList" && echo.
	)
	
	echo.
	echo.
	echo ********************    Fixed DimensionList    ********************
	echo.
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /f "*, Channel *" /s ^|find /i "%regpth%"') do (
		reg add "%%a" /v DimensionList /t REG_DWORD /d %dimension_list_value% /f > nul
		set /a num += 1
	)
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /v DimensionList /s') do (
		echo Path : %%a|find /i "%regpth%"
		echo Key  : %%a|find /i "DimensionList" && echo.
	)
	
	echo %num% DimensionList fixed
	echo.
	
	set /a num = 0
	
	echo.
	echo.
	echo.
	echo.
	echo ===================================================================
	echo ********************    Current MaxOutWidth    ********************
	echo.
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /v MaxOutWidth /s') do (
		echo Path : %%a|find /i "%regpth%"
		echo Key  : %%a|find /i "MaxOutWidth" && echo.
	)
	
	echo.
	echo.
	echo ********************    Fixed MaxOutWidth    ********************
	echo.
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /f "*, Channel *" /s ^|find /i "%regpth%"') do (
		reg add "%%a" /v MaxOutWidth /t REG_DWORD /d %max_out_width% /f > nul
		set /a num += 1
	)
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /v MaxOutWidth /s') do (
		echo Path : %%a|find /i "%regpth%"
		echo Key  : %%a|find /i "MaxOutWidth" && echo.
	)
	echo %num% MaxOutWidth fixed
	echo.
	
	set /a num = 0
	
	echo.
	echo.
	echo.
	echo.
	echo ====================================================================
	echo ********************    Current MaxOutHeight    ********************
	echo.
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /v MaxOutHeight /s') do (
		echo Path : %%a|find /i "%regpth%"
		echo Key  : %%a|find /i "MaxOutHeight" && echo.
	)
	
	echo.
	echo.
	echo ********************    Fixed MaxOutHeight    ********************
	echo.
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /f "*, Channel *" /s ^|find /i "%regpth%"') do (
		reg add "%%a" /v MaxOutHeight /t REG_DWORD /d %max_out_height% /f > nul
		set /a num += 1
	)
	
	for /f "tokens=*" %%a in ('reg query "%regpth%" /v MaxOutHeight /s') do (
		echo Path : %%a|find /i "%regpth%"
		echo Key  : %%a|find /i "MaxOutHeight" && echo.
	)
	echo %num% MaxOutHeight fixed
	echo.
	
	set /a num = 0

	echo.
	echo.
	echo =====================================================================
	echo ********************       enable ProCapture     ********************

	set /a num = 0

	devcon_%processor_arch%\devcon.exe enable %ven_id%

	echo.
	echo.
	set /a num = 0

goto end	

	set /p ctrl=Please restart the computer(Y/N) :
	
	if /i "%ctrl%"=="Y" (
		shutdown -r -t 0
	) 

:end
	
pause
exit